/*
 * $ java-algs4 Generator 5 4 1 123 2023
 *   2   1   3   1 
 *   3   3   1   3 
 *   2   1   3   3 
 *   1   2   2   1 
 *   2   1   3   1 
 * $ 
 */

import edu.princeton.cs.algs4.StdOut;
import edu.princeton.cs.algs4.StdRandom;

public class Generator {

    public static String randomString(int L, String alpha) {
	char[] a = new char[L];
	for (int i = 0; i < L; i++)  { 
	    int t = StdRandom.uniformInt(alpha.length());
	    a[i] = alpha.charAt(t);
	}
	return new String(a);
    }
    
    public static void main(String[] args) {
	int M = Integer.parseInt(args[0]);
	int N = Integer.parseInt(args[1]);
	int L = Integer.parseInt(args[2]);
	String alpha = args[3];
	long seed = Long.parseLong(args[4]);

	StdRandom.setSeed(seed);
	for (int i = 0; i < M; i++) {
	    for (int j = 0; j < N; j++)
		StdOut.print("  " + randomString(L, alpha) + " ");
	    StdOut.println();
	}
    }

}
