/* 
 * $ java-algs4 SeveralDates 15 11 2023 3 8888
 * 27
 * 16/12/2023
 * 16/1/2024
 * 17/11/2023
 * 17/12/2023
 * [...]
 * 15/1/2024
 * $ 
 */

import edu.princeton.cs.algs4.StdOut;
import edu.princeton.cs.algs4.StdIn;
import edu.princeton.cs.algs4.StdRandom;

public class SeveralDates
{
    public static void main(String[] args)
    {
	int d = Integer.parseInt(args[0]);
	int m = Integer.parseInt(args[1]);
	int y = Integer.parseInt(args[2]);
	int t = Integer.parseInt(args[3]);
	long seed = Long.parseLong(args[4]);

	int[] dd = new int[t];
	int[] mm = new int[t];
	int[] yy = new int[t];

	dd[0] = d > 28 ? d - 28 : d; // don't want 29, 30, 31
	if (dd[0] == 0) dd[0] = 1;
	for (int i = 0; i < t - 1; i++) 
	    dd[i + 1] = ++d > 28 ? d - 28 : d;

	mm[0] = m;
	for (int i = 0; i < t - 1; i++) 
	    mm[i + 1] = ++m > 12 ? 1 : m;

	yy[0] = y;
	for (int i = 0; i < t - 1; i++) 
	    yy[i + 1] = ++y;

	int l = 0;
	int[][] dates = new int[t * t * t][3];
	for (int i = 0; i < t; i++) 	
	    for (int j = 0; j < t; j++) 	
		for (int k = 0; k < t; k++) {
		    dates[l][0] = dd[i];
		    dates[l][1] = mm[j];
		    dates[l++][2] = yy[k];
		}
	StdOut.println(dates.length);
	StdRandom.setSeed(seed);
	StdRandom.shuffle(dates);
	for (int i = 0; i < t * t * t; i++) 
	    StdOut.println(dates[i][0] + "/" + dates[i][1] + "/" + dates[i][2]);
    }
}
